#!/usr/bin/env python

import os, shutil

class haxfn:
   def __init__( self, scr_directory, fileset ):
      self.s = scr_directory
      self.f = fileset

   def __call__( self, work_directory):
      myhax(self.s, self.f, work_directory)

def acqeaeri_file_hax( acqeaeri_exe ):
    """ deal with ACQEAERI not writing output files to current working directory (CWD)
    usage: 
    haxfn = acqeaeri_file_hax(Config.ACQEAERI_EXE)
    .. run acqeaeri ..
    haxfn(Config.workDir())
    """
    # find directory name for acqeaeri.exe - this is where files will land instead of CWD
    src_directory =  os.path.split( acqeaeri_exe )[0]
    # use walk() or glob() to get the fileset, set of all current files in the directory
    for root, dirs, files in os.walk( src_directory ):
       if root == src_directory:
          fileset = files
    return haxfn( src_directory, fileset )

def myhax( src_directory, fileset, work_directory ):
   """ generated function which uses shutil to move files not in files_not_to_move to cwd
   """
   # find the new files and move them to the working directory
   for root, dirs, files in os.walk( src_directory ):
      if root == src_directory:
         new_fileset = files
   for f in fileset:
      new_fileset.remove( f )
   for f in new_fileset:
       src = "%s/%s" % ( src_directory, f )
       dst = "%s/%s" % ( work_directory, f )
       shutil.move( src, dst )  

